searchNodes=[{"ref":"SmartCity.BaseStruct.html","title":"SmartCity.BaseStruct","type":"module","doc":"This module provides deserialization and atomization for structs"},{"ref":"SmartCity.BaseStruct.html#new/1","title":"SmartCity.BaseStruct.new/1","type":"function","doc":""},{"ref":"SmartCity.Data.html","title":"SmartCity.Data","type":"module","doc":"Message struct shared amongst all SmartCity microservices. const DataMessage = { &quot;dataset_id&quot;: &quot;&quot;, // UUID &quot;payload&quot;: {}, &quot;_metadata&quot;: { // cannot be used safely &quot;orgName&quot;: &quot;&quot;, // ~r/^[a-zA-Z_]+$/ &quot;dataName&quot;: &quot;&quot;, // ~r/^[a-zA-Z_]+$/ &quot;stream&quot;: true }, &quot;operational&quot;: { &quot;timing&quot;: [{ &quot;startTime&quot;: &quot;&quot;, // iso8601 &quot;endTime&quot;: &quot;&quot;, // iso8601 &quot;app&quot;: &quot;&quot;, // microservice generating timing data &quot;label&quot;: &quot;&quot; // label for this particular timing data }] } }"},{"ref":"SmartCity.Data.html#add_timing/2","title":"SmartCity.Data.add_timing/2","type":"function","doc":"Adds a SmartCity.Data.Timing to the list of timings in this SmartCity.Data. The timing will be validated to ensure both start and end times have been set. Returns a SmartCity.Data struct with new_timing prepended to existing timings list. Parameters message: A SmartCity.Data new_timing: A timing you want to add. Must have start_time and end_time set"},{"ref":"SmartCity.Data.html#encode/1","title":"SmartCity.Data.encode/1","type":"function","doc":"Encodes SmartCity.Data into JSON. Typically used right before sending as a Kafka message."},{"ref":"SmartCity.Data.html#encode!/1","title":"SmartCity.Data.encode!/1","type":"function","doc":"Encodes SmartCity.Data into JSON. Typically used right before sending as a Kafka message. Raises an error if it fails to convert to a JSON string."},{"ref":"SmartCity.Data.html#end_of_data/0","title":"SmartCity.Data.end_of_data/0","type":"macro","doc":"Defines the string that will be the payload of the last message in a dataset."},{"ref":"SmartCity.Data.html#get_all_timings/1","title":"SmartCity.Data.get_all_timings/1","type":"function","doc":"Get all timings on this Data Returns a list of SmartCity.Data.Timing structs or [] Parameters data_message: The message to extract timings from"},{"ref":"SmartCity.Data.html#new/1","title":"SmartCity.Data.new/1","type":"function","doc":"Returns a new SmartCity.Data struct. SmartCity.Data.Timing structs will be created along the way. Can be created from: map with string keys map with atom keys JSON Examples iex&gt; SmartCity.Data.new(%{dataset_id: &quot;a_guid&quot;, payload: &quot;the_data&quot;, _metadata: %{org: &quot;scos&quot;, name: &quot;example&quot;}, operational: %{timing: [%{app: &quot;app name&quot;, label: &quot;function name&quot;, start_time: &quot;2019-05-06T19:51:41+00:00&quot;, end_time: &quot;2019-05-06T19:51:51+00:00&quot;}]}}) {:ok, %SmartCity.Data{ dataset_id: &quot;a_guid&quot;, payload: &quot;the_data&quot;, _metadata: %{org: &quot;scos&quot;, name: &quot;example&quot;}, operational: %{ timing: [%SmartCity.Data.Timing{ app: &quot;app name&quot;, end_time: &quot;2019-05-06T19:51:51+00:00&quot;, label: &quot;function name&quot;, start_time: &quot;2019-05-06T19:51:41+00:00&quot;}] } }}"},{"ref":"SmartCity.Data.html#timed_new/2","title":"SmartCity.Data.timed_new/2","type":"function","doc":"Creates a new SmartCity.Data struct using new/1 and adds timing information to the message. Returns a SmartCity.Data struct with new_timing prepended to existing timings list. Parameters message: A SmartCity.Data app: The application that is asking to create the new SmartCity.Data. Ex. reaper or voltron"},{"ref":"SmartCity.Data.html#timed_transform/3","title":"SmartCity.Data.timed_transform/3","type":"function","doc":"Transforms the SmartCity.Data payload field with the given unary function and replaces it in the message. Additionally, returns a SmartCity.Data struct with new_timing prepended to existing timings list. Parameters message: A SmartCity.Data app: The application that is asking to create the new SmartCity.Data. Ex. reaper or voltron function: an arity 1 (/1) function that will transform the payload in the provided message"},{"ref":"SmartCity.Data.html#t:payload/0","title":"SmartCity.Data.payload/0","type":"type","doc":""},{"ref":"SmartCity.Data.html#t:t/0","title":"SmartCity.Data.t/0","type":"type","doc":""},{"ref":"SmartCity.Data.Timing.html","title":"SmartCity.Data.Timing","type":"module","doc":"Timing struct for adding timing metrics to SmartCity.Data messages"},{"ref":"SmartCity.Data.Timing.html#current_time/0","title":"SmartCity.Data.Timing.current_time/0","type":"function","doc":"Gets the current time. This function should always be used for generating times to be used in timings to ensure consistency across all services. Returns current UTC Time in ISO8601 format"},{"ref":"SmartCity.Data.Timing.html#measure/3","title":"SmartCity.Data.Timing.measure/3","type":"function","doc":"Wraps the results of a function call with measured timing information Returns {:ok, result, timing} on success, or {:error, reason} on failure"},{"ref":"SmartCity.Data.Timing.html#new/1","title":"SmartCity.Data.Timing.new/1","type":"function","doc":"Creates a new SmartCity.Data.Timing from opts. Returns a SmartCity.Data.Timing struct or raises ArgumentError Parameters opts: Keyword list or map containing struct attributes Required keys: `app`, `label` See [`Kernel.struct!/2`](https://hexdocs.pm/elixir/Kernel.html#struct!/2)."},{"ref":"SmartCity.Data.Timing.html#new/4","title":"SmartCity.Data.Timing.new/4","type":"function","doc":"Creates a new SmartCity.Data.Timing struct, passing in all fields. Returns a SmartCity.Data.Timing struct or raises ArgumentError. Parameters app: application for which timing metrics are being measured label: description of timing measurement start_time: time when measurement has begun end_time: time when measurement has finished Examples iex&gt; SmartCity.Data.Timing.new(&quot;foo&quot;, &quot;bar&quot;, &quot;not_validated&quot;, &quot;not_validated&quot;) %SmartCity.Data.Timing{ app: &quot;foo&quot;, label: &quot;bar&quot;, start_time: &quot;not_validated&quot;, end_time: &quot;not_validated&quot; }"},{"ref":"SmartCity.Data.Timing.html#validate/1","title":"SmartCity.Data.Timing.validate/1","type":"function","doc":"Validate that all required keys are present and valid (not nil). Set by @validate_keys module attribute. Currently checks: app, label Returns {:ok, timing} on success or {:error, reason} on failure Parameters timing: The SmartCity.Data.Timing struct to validate"},{"ref":"SmartCity.Data.Timing.html#validate!/1","title":"SmartCity.Data.Timing.validate!/1","type":"function","doc":"Validate that all required keys are present and valid (not nil). Returns timing on success, or raises ArgumentError on failure See validate/1"},{"ref":"SmartCity.Data.Timing.html#t:t/0","title":"SmartCity.Data.Timing.t/0","type":"type","doc":""},{"ref":"SmartCity.DataWriteComplete.html","title":"SmartCity.DataWriteComplete","type":"module","doc":"Defines a data persisted event."},{"ref":"SmartCity.DataWriteComplete.html#new/1","title":"SmartCity.DataWriteComplete.new/1","type":"function","doc":"Instantiates an instance of a data write complete event struct."},{"ref":"SmartCity.DataWriteComplete.html#t:id/0","title":"SmartCity.DataWriteComplete.id/0","type":"type","doc":""},{"ref":"SmartCity.DataWriteComplete.html#t:t/0","title":"SmartCity.DataWriteComplete.t/0","type":"type","doc":""},{"ref":"SmartCity.DataWriteComplete.html#t:timestamp/0","title":"SmartCity.DataWriteComplete.timestamp/0","type":"type","doc":""},{"ref":"SmartCity.Dataset.html","title":"SmartCity.Dataset","type":"module","doc":"Struct defining a dataset definition and functions for retrieving key elements of the dataset for handling. const Dataset = { &quot;id&quot;: &quot;&quot;, // UUID &quot;business&quot;: { // Project Open Data Metadata Schema v1.1 &quot;authorEmail&quot;: &quot;&quot;, &quot;authorName&quot;: &quot;&quot;, &quot;benefitRating&quot;: 0, // value between 0.0 and 1.0 &quot;categories&quot;: [&quot;&quot;], &quot;conformsToUri&quot;: &quot;&quot;, &quot;contactEmail&quot;: &quot;&quot;, &quot;contactName&quot;: &quot;&quot;, &quot;dataTitle&quot;: &quot;&quot;, // user friendly (dataTitle) &quot;describedByMimeType&quot;: &quot;&quot;, &quot;describedByUrl&quot;: &quot;&quot;, &quot;description&quot;: &quot;&quot;, &quot;homepage&quot;: &quot;&quot;, &quot;issuedDate&quot;: &quot;&quot;, &quot;keywords&quot;: [&quot;&quot;], &quot;language&quot;: &quot;&quot;, &quot;license&quot;: &quot;&quot;, &quot;modifiedDate&quot;: &quot;&quot;, &quot;orgTitle&quot;: &quot;&quot;, // user friendly (orgTitle) &quot;parentDataset&quot;: &quot;&quot;, &quot;publishFrequency&quot;: &quot;&quot;, &quot;referenceUrls&quot;: [&quot;&quot;], &quot;rights&quot;: &quot;&quot;, &quot;riskRating&quot;: 0, // value between 0.0 and 1.0 &quot;spatial&quot;: &quot;&quot;, &quot;temporal&quot;: &quot;&quot; }, &quot;technical&quot;: { &quot;allow_duplicates&quot;: true &quot;authHeaders&quot;: {&quot;header1&quot;: &quot;&quot;, &quot;header2&quot;: &quot;&quot;} &quot;authBody&quot;: {&quot;name&quot;: &quot;&quot;, &quot;clientID&quot;: &quot;&quot;} &quot;authUrl&quot;: &quot;&quot;, &quot;cadence&quot;: &quot;&quot;, &quot;dataName&quot;: &quot;&quot;, // ~r/[a-zA-Z_]+$/ &quot;orgId&quot;: &quot;&quot;, &quot;orgName&quot;: &quot;&quot;, // ~r/[a-zA-Z_]+$/ &quot;protocol&quot;: &quot;&quot;, // List of protocols to use. Defaults to nil. Can be [http1, http2] &quot;schema&quot;: [{ &quot;name&quot;: &quot;&quot;, &quot;type&quot;: &quot;&quot;, &quot;description&quot;: &quot;&quot; }], &quot;sourceFormat&quot;: &quot;&quot;, &quot;sourceHeaders&quot;: { &quot;header1&quot;: &quot;&quot;, &quot;header2&quot;: &quot;&quot; }, &quot;sourceQueryParams&quot;: { &quot;key1&quot;: &quot;&quot;, &quot;key2&quot;: &quot;&quot; }, &quot;sourceType&quot;: &quot;&quot;, // remote|stream|ingest|host &quot;sourceUrl&quot;: &quot;&quot;, &quot;systemName&quot;: &quot;&quot;, // ${orgName}__${dataName} &quot;topLevelSelector&quot;: &quot;&quot; } }"},{"ref":"SmartCity.Dataset.html#delete/2","title":"SmartCity.Dataset.delete/2","type":"function","doc":""},{"ref":"SmartCity.Dataset.html#get/3","title":"SmartCity.Dataset.get/3","type":"function","doc":""},{"ref":"SmartCity.Dataset.html#is_host?/1","title":"SmartCity.Dataset.is_host?/1","type":"function","doc":"Returns true if SmartCity.Dataset.Technical sourceType field is host"},{"ref":"SmartCity.Dataset.html#is_ingest?/1","title":"SmartCity.Dataset.is_ingest?/1","type":"function","doc":"Returns true if SmartCity.Dataset.Technical sourceType field is ingest"},{"ref":"SmartCity.Dataset.html#is_remote?/1","title":"SmartCity.Dataset.is_remote?/1","type":"function","doc":"Returns true if SmartCity.Dataset.Technical sourceType field is remote"},{"ref":"SmartCity.Dataset.html#is_stream?/1","title":"SmartCity.Dataset.is_stream?/1","type":"function","doc":"Returns true if SmartCity.Dataset.Technical sourceType field is stream"},{"ref":"SmartCity.Dataset.html#new/1","title":"SmartCity.Dataset.new/1","type":"function","doc":"Returns a new SmartCity.Dataset struct. SmartCity.Dataset.Business and SmartCity.Dataset.Technical structs will be created along the way. Parameters msg : map defining values of the struct to be created. Can be initialized by map with string keys map with atom keys JSON"},{"ref":"SmartCity.Dataset.html#put/3","title":"SmartCity.Dataset.put/3","type":"function","doc":""},{"ref":"SmartCity.Dataset.html#t:id/0","title":"SmartCity.Dataset.id/0","type":"type","doc":""},{"ref":"SmartCity.Dataset.html#t:t/0","title":"SmartCity.Dataset.t/0","type":"type","doc":""},{"ref":"SmartCity.Dataset.Business.html","title":"SmartCity.Dataset.Business","type":"module","doc":"A struct representing the business data portion of a dataset struct definition (represented by SmartCity.Dataset) You probably won&#39;t need to access this module directly; SmartCity.Dataset.new/1 will build this for you"},{"ref":"SmartCity.Dataset.Business.html#delete/2","title":"SmartCity.Dataset.Business.delete/2","type":"function","doc":""},{"ref":"SmartCity.Dataset.Business.html#get/3","title":"SmartCity.Dataset.Business.get/3","type":"function","doc":""},{"ref":"SmartCity.Dataset.Business.html#new/1","title":"SmartCity.Dataset.Business.new/1","type":"function","doc":"Returns a new SmartCity.Dataset.Business struct. Can be created from Map with string or atom keys. Parameters msg: Map with string or atom keys that defines the dataset&#39;s business metadata. See SmartCity.Dataset.Business typespec for available keys. Required Keys dataTitle description modifiedDate orgTitle contactName contactEmail License will default to http://opendefinition.org/licenses/cc-by/ if not provided"},{"ref":"SmartCity.Dataset.Business.html#put/3","title":"SmartCity.Dataset.Business.put/3","type":"function","doc":""},{"ref":"SmartCity.Dataset.Business.html#t:license_or_default/0","title":"SmartCity.Dataset.Business.license_or_default/0","type":"type","doc":""},{"ref":"SmartCity.Dataset.Business.html#t:not_required/0","title":"SmartCity.Dataset.Business.not_required/0","type":"type","doc":""},{"ref":"SmartCity.Dataset.Business.html#t:t/0","title":"SmartCity.Dataset.Business.t/0","type":"type","doc":""},{"ref":"SmartCity.Dataset.Technical.html","title":"SmartCity.Dataset.Technical","type":"module","doc":"A struct defining technical metadata on a dataset."},{"ref":"SmartCity.Dataset.Technical.html#delete/2","title":"SmartCity.Dataset.Technical.delete/2","type":"function","doc":""},{"ref":"SmartCity.Dataset.Technical.html#get/3","title":"SmartCity.Dataset.Technical.get/3","type":"function","doc":""},{"ref":"SmartCity.Dataset.Technical.html#new/1","title":"SmartCity.Dataset.Technical.new/1","type":"function","doc":"Returns a new SmartCity.Dataset.Technical. Can be created from Map with string or atom keys. Raises an ArgumentError when passed invalid input Parameters msg: Map with string or atom keys that defines the dataset&#39;s technical metadata Required Keys dataName orgName systemName sourceUrl sourceFormat sourceType will default to &quot;remote&quot; cadence will default to &quot;never&quot;"},{"ref":"SmartCity.Dataset.Technical.html#put/3","title":"SmartCity.Dataset.Technical.put/3","type":"function","doc":""},{"ref":"SmartCity.Dataset.Technical.html#t:not_required/1","title":"SmartCity.Dataset.Technical.not_required/1","type":"type","doc":""},{"ref":"SmartCity.Dataset.Technical.html#t:t/0","title":"SmartCity.Dataset.Technical.t/0","type":"type","doc":""},{"ref":"SmartCity.Event.html","title":"SmartCity.Event","type":"module","doc":"Defines macros for encoding event types the Smart City platform will respond to in any of the various micro service components in a central location shared by all components."},{"ref":"SmartCity.Event.html#data_extract_end/0","title":"SmartCity.Event.data_extract_end/0","type":"macro","doc":"Signals a dataset has completed the extraction process and the final message has been written to the raw ingestion topic."},{"ref":"SmartCity.Event.html#data_extract_start/0","title":"SmartCity.Event.data_extract_start/0","type":"macro","doc":"Signals data for a dataset is about to be downloaded into the platform, parsed, and written to the raw ingestion topic."},{"ref":"SmartCity.Event.html#data_ingest_end/0","title":"SmartCity.Event.data_ingest_end/0","type":"macro","doc":"Signals a dataset has completed an ingestion process through the pipeline from end to end and been persisted."},{"ref":"SmartCity.Event.html#data_ingest_start/0","title":"SmartCity.Event.data_ingest_start/0","type":"macro","doc":"Signals a dataset is about to be retrieved and begin loading into the ingestion pipeline."},{"ref":"SmartCity.Event.html#data_standardization_end/0","title":"SmartCity.Event.data_standardization_end/0","type":"macro","doc":"Signals that data standardization is complete"},{"ref":"SmartCity.Event.html#data_write_complete/0","title":"SmartCity.Event.data_write_complete/0","type":"macro","doc":"Signals that writing some data for a dataset has completed"},{"ref":"SmartCity.Event.html#dataset_delete/0","title":"SmartCity.Event.dataset_delete/0","type":"macro","doc":"Signals that a dataset should be deleted"},{"ref":"SmartCity.Event.html#dataset_disable/0","title":"SmartCity.Event.dataset_disable/0","type":"macro","doc":"Signals that a dataset should be disabled."},{"ref":"SmartCity.Event.html#dataset_extract_complete/0","title":"SmartCity.Event.dataset_extract_complete/0","type":"macro","doc":"Signals that dataset extraction has completed"},{"ref":"SmartCity.Event.html#dataset_extract_start/0","title":"SmartCity.Event.dataset_extract_start/0","type":"macro","doc":"Signals that a dataset extraction is starting"},{"ref":"SmartCity.Event.html#dataset_update/0","title":"SmartCity.Event.dataset_update/0","type":"macro","doc":"Defines an update event to a dataset within the system. The system treats create events as a subset of updates."},{"ref":"SmartCity.Event.html#error_data_extract/0","title":"SmartCity.Event.error_data_extract/0","type":"macro","doc":"Declares an error occurred during an attempted data extraction."},{"ref":"SmartCity.Event.html#error_data_ingest/0","title":"SmartCity.Event.error_data_ingest/0","type":"macro","doc":"Declares an error occurred during an attempted data ingestion."},{"ref":"SmartCity.Event.html#error_dataset_update/0","title":"SmartCity.Event.error_dataset_update/0","type":"macro","doc":"Declares an error occurred during the attempted upsert of a dataset."},{"ref":"SmartCity.Event.html#error_file_ingest/0","title":"SmartCity.Event.error_file_ingest/0","type":"macro","doc":"Declares an error occurred during an attempted file ingestion."},{"ref":"SmartCity.Event.html#error_organization_update/0","title":"SmartCity.Event.error_organization_update/0","type":"macro","doc":"Declares an error occurred during the attempted upsert of an organization."},{"ref":"SmartCity.Event.html#file_ingest_end/0","title":"SmartCity.Event.file_ingest_end/0","type":"macro","doc":"Signals a non-ingestable data file has been successfully uploaded to the object store bucket."},{"ref":"SmartCity.Event.html#file_ingest_start/0","title":"SmartCity.Event.file_ingest_start/0","type":"macro","doc":"Signals a non-ingestable data file is about to be downloaded to the platform and stored in the object store bucket."},{"ref":"SmartCity.Event.html#file_upload/0","title":"SmartCity.Event.file_upload/0","type":"macro","doc":"Signals that a new file has been uploaded to the object store and made available for the rest of the system."},{"ref":"SmartCity.Event.html#hosted_file_complete/0","title":"SmartCity.Event.hosted_file_complete/0","type":"macro","doc":"Hosted file and been downloaded and stored"},{"ref":"SmartCity.Event.html#hosted_file_start/0","title":"SmartCity.Event.hosted_file_start/0","type":"macro","doc":"Signals to file should be downloaded"},{"ref":"SmartCity.Event.html#organization_update/0","title":"SmartCity.Event.organization_update/0","type":"macro","doc":"Defines an update event to an organization within the system. The system treats create events as a subset of updates."},{"ref":"SmartCity.Event.html#user_organization_associate/0","title":"SmartCity.Event.user_organization_associate/0","type":"macro","doc":"Defines a user organization relationship."},{"ref":"SmartCity.Helpers.html","title":"SmartCity.Helpers","type":"module","doc":"Functions used across SmartCity modules."},{"ref":"SmartCity.Helpers.html#deep_merge/2","title":"SmartCity.Helpers.deep_merge/2","type":"function","doc":"Merges two maps into one, including sub maps. Matching keys from the right map will override their corresponding key in the left map."},{"ref":"SmartCity.Helpers.html#mime_type/1","title":"SmartCity.Helpers.mime_type/1","type":"function","doc":"Standardize file type definitions by deferring to the official media type of the file based on a supplied extension."},{"ref":"SmartCity.Helpers.html#to_atom_keys/1","title":"SmartCity.Helpers.to_atom_keys/1","type":"function","doc":"Convert a map with string keys to one with atom keys. Will convert keys nested in a sub-map or a map that is part of a list. Ignores atom keys. Examples iex&gt; SmartCity.Helpers.to_atom_keys(%{&quot;abc&quot; =&gt; 123}) %{abc: 123} iex&gt; SmartCity.Helpers.to_atom_keys(%{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; &quot;c&quot;}}) %{a: %{b: &quot;c&quot;}} iex&gt; SmartCity.Helpers.to_atom_keys(%{&quot;a&quot; =&gt; [%{&quot;b&quot; =&gt; &quot;c&quot;}]}) %{a: [%{b: &quot;c&quot;}]}"},{"ref":"SmartCity.Helpers.html#t:file_type/0","title":"SmartCity.Helpers.file_type/0","type":"type","doc":""},{"ref":"SmartCity.Helpers.html#t:mime_type/0","title":"SmartCity.Helpers.mime_type/0","type":"type","doc":""},{"ref":"SmartCity.HostedFile.html","title":"SmartCity.HostedFile","type":"module","doc":"Defines the information needed to process uploaded files by components of the system including the files&#39; type, parent identifier, and location info."},{"ref":"SmartCity.HostedFile.html#new/1","title":"SmartCity.HostedFile.new/1","type":"function","doc":"Instantiates an instance of a file upload event struct."},{"ref":"SmartCity.HostedFile.html#t:bucket/0","title":"SmartCity.HostedFile.bucket/0","type":"type","doc":""},{"ref":"SmartCity.HostedFile.html#t:id/0","title":"SmartCity.HostedFile.id/0","type":"type","doc":""},{"ref":"SmartCity.HostedFile.html#t:key/0","title":"SmartCity.HostedFile.key/0","type":"type","doc":""},{"ref":"SmartCity.HostedFile.html#t:t/0","title":"SmartCity.HostedFile.t/0","type":"type","doc":""},{"ref":"SmartCity.Organization.html","title":"SmartCity.Organization","type":"module","doc":"Struct defining an organization update event. const Organization = { &quot;description&quot;: &quot;&quot;, &quot;dn&quot;: &quot;&quot;, // LDAP distinguished name &quot;homepage&quot;: &quot;&quot;, &quot;id&quot;: &quot;&quot;, // uuid &quot;logoUrl&quot;: &quot;&quot;, &quot;orgName&quot;: &quot;&quot;, // system friendly &quot;orgTitle&quot;: &quot;&quot; // user friendly }"},{"ref":"SmartCity.Organization.html#new/1","title":"SmartCity.Organization.new/1","type":"function","doc":"Returns a new SmartCity.Organization struct. Can be created from: map with string keys map with atom keys JSON"},{"ref":"SmartCity.Organization.html#t:id/0","title":"SmartCity.Organization.id/0","type":"type","doc":""},{"ref":"SmartCity.Organization.html#t:reason/0","title":"SmartCity.Organization.reason/0","type":"type","doc":""},{"ref":"SmartCity.Organization.html#t:t/0","title":"SmartCity.Organization.t/0","type":"type","doc":""},{"ref":"SmartCity.Organization.NotFound.html","title":"SmartCity.Organization.NotFound","type":"exception","doc":""},{"ref":"SmartCity.SchemaGenerator.html","title":"SmartCity.SchemaGenerator","type":"module","doc":"Take the first row of data from a datasample and generates an implied schema from that with all field types being strings. Lists and nested maps are generated with their subschemas where applicable."},{"ref":"SmartCity.SchemaGenerator.html#generate_schema/1","title":"SmartCity.SchemaGenerator.generate_schema/1","type":"function","doc":""},{"ref":"SmartCity.UserOrganizationAssociate.html","title":"SmartCity.UserOrganizationAssociate","type":"module","doc":"Defines a user organization association."},{"ref":"SmartCity.UserOrganizationAssociate.html#new/1","title":"SmartCity.UserOrganizationAssociate.new/1","type":"function","doc":"Instantiates an instance of a user organization associate event struct."},{"ref":"SmartCity.UserOrganizationAssociate.html#t:org_id/0","title":"SmartCity.UserOrganizationAssociate.org_id/0","type":"type","doc":""},{"ref":"SmartCity.UserOrganizationAssociate.html#t:t/0","title":"SmartCity.UserOrganizationAssociate.t/0","type":"type","doc":""},{"ref":"SmartCity.UserOrganizationAssociate.html#t:user_id/0","title":"SmartCity.UserOrganizationAssociate.user_id/0","type":"type","doc":""},{"ref":"readme.html","title":"SmartCity","type":"extras","doc":"SmartCity This library defines helper functions that are used across SmartCity modules."},{"ref":"readme.html#installation","title":"SmartCity - Installation","type":"extras","doc":"def deps do [ {:smart_city, &quot;~&gt; 3.11.0&quot;} ] end"},{"ref":"readme.html#basic-usage","title":"SmartCity - Basic Usage","type":"extras","doc":"iex&gt; SmartCity.Helpers.to_atom_keys(%{&quot;a&quot; =&gt; 1, &quot;b&quot; =&gt; 2, &quot;c&quot; =&gt; 3}) %{a: 1, b: 2, c: 3} iex&gt; SmartCity.Helpers.to_atom_keys(%{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; &quot;c&quot;}}) %{a: %{b: &quot;c&quot;}} iex&gt; SmartCity.Helpers.deep_merge(%{a: 1, b: 2}, %{a: 3, c: 4}) %{a: 3, b: 2, c: 4} Full documentation can be found at https://hexdocs.pm/smart_city/api-reference.html."},{"ref":"readme.html#contributing","title":"SmartCity - Contributing","type":"extras","doc":"The build process runs these commands: mix local.rebar --force mix local.hex --force mix deps.get mix format --check-formatted mix credo mix test"},{"ref":"readme.html#license","title":"SmartCity - License","type":"extras","doc":"SmartCity is released under the Apache 2.0 license - see the license at http://www.apache.org/licenses/LICENSE-2.0"}]